<template>
  <div class="app-container">
    
    

    <el-row  class="mb8">
      <el-col :span="4">
        <span>产品分类</span>
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAddDictOpen"
        >新增分类</el-button>
      </el-col>
      
      <el-col style="text-align:right;" :span="20">
        <!-- <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-permission="['unimall:management:export']"
        >导入产品</el-button> -->
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-permission="['unimall:management:add']"
        >新增产品</el-button>
      </el-col>
    </el-row>
    <el-row style="margin-top:20px;">
      <el-col :span="4">
        <el-tree :default-expanded-keys="[-1]" node-key="id" :data="data" :props="defaultProps" @node-click="handleNodeClick">
          <span  class="custom-tree-node" slot-scope="{ node, data }">
            <span>{{ node.label }}</span>
            <span v-if="node.label!='全部分类'&&node.label!='未分类'">
              <el-button
                type="text"
                size="mini"
                @click="() => append(data)">
                编辑
              </el-button>
              <el-button
                type="text"
                size="mini"
                @click="() => remove(node, data)">
                删除
              </el-button>
            </span>
          </span>
        </el-tree>
        <!-- <el-dropdown>
          <span class="el-dropdown-link">
            全部分类<i class="el-icon-arrow-down el-icon--right"></i>
          </span>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item>黄金糕</el-dropdown-item>
            <el-dropdown-item>狮子头</el-dropdown-item>
            <el-dropdown-item>螺蛳粉</el-dropdown-item>
            <el-dropdown-item disabled>双皮奶</el-dropdown-item>
            <el-dropdown-item divided>蚵仔煎</el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown> -->
      </el-col>
      <el-col :span="20">
        <el-form :model="queryParams" ref="queryForm" :inline="true" label-width="68px">
          <el-form-item label="全部状态" prop="status">
            <el-select v-model="queryParams.status" placeholder="请选择状态" clearable size="small">
              <el-option label="待发布" value="已上线" />
              <el-option label="已上架" value="已上线" />
            </el-select>
          </el-form-item>
          <el-form-item label="产品标题" prop="productTitle">
            <el-input
              v-model="queryParams.productTitle"
              placeholder="请输入产品标题"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="分类" prop="classification">
            <el-input
              v-model="queryParams.classification"
              placeholder="请输入分类"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="语言" prop="classification">
            <el-select v-model="queryParams.language" placeholder="请选择语言" clearable size="small">
              <el-option label="中文" value="中文" />
              <el-option label="English" value="English" />
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>
        <el-table v-loading="loading" :data="managementList" @selection-change="handleSelectionChange">
          <!-- <el-table-column type="selection" width="55" align="center" />
          <el-table-column label="序号" align="center" prop="tableId" width="50px" /> -->
          <!-- <el-table-column label="" align="center" prop="id" /> -->
          <el-table-column label="产品标题" align="center" prop="productTitle" />
          <el-table-column label="分类" align="center" prop="classification" />
          <el-table-column label="状态" align="center" prop="status" />
          <el-table-column label="创建时间" align="center" prop="gmtCreate" width="180">
            <template slot-scope="scope">
              <span>{{ parseTime(scope.row.gmtCreate) }}</span>
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <el-button
                size="mini"
                type="text"
                icon="el-icon-edit"
                @click="handleUpdate(scope.row)"
                v-permission="['unimall:management:edit']"
              >修改</el-button>
              <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
          >删除</el-button>
            </template>
          </el-table-column>
        </el-table>
      </el-col>
    </el-row>
    
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.page"
      :limit.sync="queryParams.limit"
      @pagination="getList"
    />

    <el-dialog :title="title" :visible.sync="opendict" width="500px">
      <el-form ref="form" label-width="80px">
      <el-form-item label="分类名称">
        <el-input v-model="dict.classifyName" placeholder="请输入分类名称" />
      </el-form-item>
      <el-form-item label="分类语言">
        <el-radio-group v-model="dict.language">
          <el-radio-button label="中文"></el-radio-button>
          <el-radio-button label="English"></el-radio-button>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="分类标题">
        <el-input v-model="dict.classifyTitle" placeholder="请输入分类标题" />
      </el-form-item>
      <el-form-item label="分类描述">
        <el-input
                type="textarea"
                :rows="4"
                maxlength="500"
                placeholder="请输入分类描述"
                v-model="dict.classifyDescribe">
        </el-input>
      </el-form-item>
      <el-form-item label="分类图标">
        <el-upload
          ref="mYupload"
          class="avatar-uploader"
          :headers="headers"
          :action="uploadPath"
          :show-file-list="false"
          :on-success="uploadSuccessHandle"
          :before-upload="onBeforeUpload">
            <img v-if="dict.classifyIcon" :src="dict.classifyIcon" class="avatar">
            <i v-else class="el-icon-plus avatar-uploader-icon"></i>
        </el-upload>
      </el-form-item>
      <el-form-item label="分类封面">
        <el-upload
          ref="mYupload1"
          class="avatar-uploader"
          :headers="headers"
          :action="uploadPath"
          :show-file-list="false"
          :on-success="uploadSuccessHandle1"
          :before-upload="onBeforeUpload1">
            <img v-if="dict.classifyImage" :src="dict.classifyImage" class="avatar">
            <i v-else class="el-icon-plus avatar-uploader-icon"></i>
        </el-upload>
      </el-form-item>
    </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="handleAddDict">确 定</el-button>
        <el-button @click="opendict = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listDict, addDict, editDict, delDict, } from "@/api/cloud/articleManagement";
import {  listProductManagement, delProductManagement,  } from "@/api/cloud/productManagement";
import { uploadPath } from '@/api/storage'
  import { getToken } from '@/utils/auth'
export default {
  data() {
    return {
      uploadPath,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 总条数
      total: 0,
      dict:{
        classifyType:'product_type',
        language:'中文'
      },
      title:'新增分类',
      // 文章管理信息表格数据
      managementList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      opendict:false,
      // 查询参数
      queryParams: {
        page: 1,
        limit: 10,
        productTitle: undefined,
        productIntroduction: undefined,
        coverImage: undefined,
        classification: undefined,
        productTemplate: undefined,
        status: undefined,
        gmtCreate: undefined,
        gmtUpdate: undefined,
        deleteFlag: undefined
      },
      data: [{
          label: '全部分类',
          id:-1,
          children: [{label: '未分类',id:0},]
        }],
        defaultProps: {
          children: 'children',
          label: 'label'
        },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        gmtCreate: [
          { required: true, message: "不能为空", trigger: "blur" }
        ],        gmtUpdate: [
          { required: true, message: "不能为空", trigger: "blur" }
        ],         
      }
    };
  },
  created() {
    this.getList();
  },
  computed: {
    headers() {
      return {
        accessToken: getToken()
      }
    }
  },
  methods: {
    // 上传图片了处理图片
    uploadSuccessHandle(e, file) {
        const that = this
        this.dict.classifyIcon = e.url
        this.$forceUpdate()
      },
      onBeforeUpload(file) {
        const isIMAGE = file.type === 'image/jpeg' || 'image/gif' || 'image/png' || 'image/jpg'
        const isLt1M = file.size / 1024 / 1024 < 1

        if (!isIMAGE) {
          this.$message.error('上传文件只能是图片格式!')
        }
        if (!isLt1M) {
          this.$message.error('上传文件大小不能超过 1MB!')
        }
        return isIMAGE && isLt1M
      },
      // 上传图片了处理图片
      uploadSuccessHandle1(e, file) {
        const that = this
        this.dict.classifyImage = e.url
        this.$forceUpdate()
      },
      onBeforeUpload1(file) {
        const isIMAGE = file.type === 'image/jpeg' || 'image/gif' || 'image/png' || 'image/jpg'
        const isLt1M = file.size / 1024 / 1024 < 1

        if (!isIMAGE) {
          this.$message.error('上传文件只能是图片格式!')
        }
        if (!isLt1M) {
          this.$message.error('上传文件大小不能超过 1MB!')
        }
        return isIMAGE && isLt1M
      },
    // 编辑分类
    append(data) {
      this.dict=data
      this.title='编辑分类'
      this.opendict=true
        
      },
      // 删除分类
      remove(node, data) {
        this.$confirm('是否确认删除产品管理分类"' + data.label + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          delDict(data.id).then(response => {
          if (response.data) {
            this.msgSuccess("删除分类成功");
            this.getList()
          } else {
            this.msgError(response.msg);
          }
        });
        }).catch(function() {});
       
        // const parent = node.parent;
        // const children = parent.data.children || parent.data;
        // const index = children.findIndex(d => d.id === data.id);
        // children.splice(index, 1);
      },
    /** 查询文章管理信息列表 */
    getList() {
      this.loading = true;
      listDict({classifyType:'product_type',}).then(response => {
        var data=response.data.data.items
        this.data[0].children=[{label: '未分类'},]
        for (let i = 0; i < data.length; i++) {
          data[i].label=data[i].classifyName
          this.data[0].children.push(data[i])
          
        }
        console.log(this.data,111111)
      });
      listProductManagement(this.queryParams).then(response => {
        this.managementList = response.data.data.items
        this.total = response.data.data.count
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        articleTitle: undefined,
        articleIntroduction: undefined,
        coverImage: undefined,
        classification: undefined,
        articleTemplate: undefined,
        status: "0",
        gmtCreate: undefined,
        gmtUpdate: undefined,
        deleteFlag: undefined
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!=1
      this.multiple = !selection.length
    },
    handleAddDictOpen() {
      this.title='新增分类'
      this.opendict=true
    },
    handleAddDict() {
      if(this.title=='新增分类'){
        addDict(this.dict).then(response => {
          if (response.data) {
            this.msgSuccess("新增分类成功");
            this.dict={classifyType:'product_type',language:'中文'}
            this.$refs['mYupload'].clearFiles()
            this.$refs['mYupload1'].clearFiles()
            this.opendict=false
            this.getList()
          } else {
            this.msgError(response.msg);
          }
        });
      }else{
        editDict(this.dict).then(response => {
          if (response.data) {
            this.msgSuccess("编辑分类成功");
            this.dict={classifyType:'product_type',language:'中文'}
            this.$refs['mYupload'].clearFiles()
            this.$refs['mYupload1'].clearFiles()
            this.opendict=false
            this.getList()
          } else {
            this.msgError(response.msg);
          }
        });
      }
      
    },
    
    /** 新增按钮操作 */
    handleAdd() {
      this.$router.push({name:'productAdd'})
      // this.reset();
      // this.open = true;
      // this.title = "添加文章管理信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.$router.push({name:'productEdit',query:{'Id':row.id}})
      
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids.join(',')
      this.$confirm('是否确认删除产品管理信息编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delProductManagement(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },

  }
};
</script>
<style lang="scss" scoped>
.avatar-uploader{ 
  /deep/.el-upload {
    border: 1px dashed #ccc;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
  }
}
 
.avatar-uploader .el-upload:hover {
  border-color: #409EFF;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
}
.avatar {
  width: 178px;
  height: 178px;
  display: block;
}
</style>